/*
 * File:   Project.cpp
 * Author: on8tom
 *
 * Slowest display ever
 *
 * Created on August 28, 2012, 5:29 PM
 */

#include <Arduino.h>
#include "LedControl/LedControl.h"
#include "constants.h"

LedControl lc = LedControl(12,11,10,2);

void motorStep(uint32_t, uint16_t, bool);

void setup(){
  Serial.begin(9600);
  pinMode(stepPin, OUTPUT);
  pinMode(enablePin, OUTPUT);
  pinMode(dirPin, OUTPUT);
  pinMode(endstopPin, INPUT);

  digitalWrite(enablePin, MOTOR_DISABLED);

  lc.shutdown(0,false);
  lc.shutdown(1,false);

  /* Set the brightness to a medium values */
  lc.setIntensity(0,7);
  lc.setIntensity(1,7);
  /* and clear the display */
  lc.clearDisplay(0);
  lc.clearDisplay(1);

  motorStep(3500, 1000, LINKS);
}


void loop(){
  if(Serial.available()){
    readString();
    Serial.println(firstLine);
    Serial.println(secondLine);
    writeString();
  }
}

void readString(){
  char* usedLine = firstLine;
  for(;;){
    char in = Serial.read();

    if(in == -1)
      continue;

    Serial.write(in);
    char inArray[2] = { in, '\0'};

    if(in == '\r'){
      Serial.write('\n');
      if(usedLine == firstLine)
        usedLine = secondLine;
      else
        return;
    }

    if(in >= ' ' && in <= '~'){
      if(strlen(usedLine) < 10)
        strcat(usedLine, inArray);
    }
  }
}

void writeString(){
  for(uint8_t i =0 ; i<10; i++){
    if(firstLine[i] == '\0' && secondLine[i] == '\0')
      break;

    printChar(0, firstLine[i] );
    printChar(1, secondLine[i] );
    delay(1500);

    lc.clearDisplay(0);
    lc.clearDisplay(1);

    motorStep(3000,83,RECHTS);
  }

  motorStep(3000, 1000, LINKS);

  for(uint8_t i = 0; i < 11; i++){
    memcpy(firstLine, "\0", 1);
    memcpy(secondLine, "\0", 1);
  }
}

void printChar(uint8_t line,char in){
  for(uint8_t i = 0; i < 5; i++){
    lc.setRow(line,i+1,alfabet[in - ' '][i] >> 1);
  }
}

void motorStep(uint32_t Delay, uint16_t n, bool dir){
  Delay = min(16383, Delay);

  //set direction
  digitalWrite(dirPin, dir);
  //enable H-bridge
  digitalWrite(enablePin, MOTOR_ENABLED);

  //delay divide by 2
  Delay /= 2;

  for (uint16_t i=0; i < n; i++){
    delayMicroseconds(Delay);
    if (digitalRead(endstopPin) == LOW || (digitalRead(endstopPin) == HIGH && dir == RECHTS)) {
      digitalWrite(stepPin, HIGH);
    }
    delayMicroseconds(Delay);
    if (digitalRead(endstopPin) == LOW || (digitalRead(endstopPin) == HIGH && dir == RECHTS) ){
      digitalWrite(stepPin, LOW);
   }

  }
  digitalWrite(enablePin, MOTOR_DISABLED);
}